/* add various spectra files
 *
 * G.Kumbartzki
 * 4-22-99
 *
 */

#include <stdio.h>

#include "dacf.h"
#include <string.h>
#include <stdlib.h>
#include <stdarg.h>
#include <unistd.h>
#include <fcntl.h>

struct filehead flhd;

float hdata[HSIZ];        	/* internal data array */
float ndata [HSIZ];
float *pd;
int fd;
char filnam[128];
int actual_read(int,int,int);

int main()
{
  int i,j;
  int ch;
  int cnt;			/* count input spectra */
  char errstr[80];

  for(i=0;i<HSIZ;i++)
    ndata[i] = 0;
  pd = hdata;
  fprintf(stderr,"Type 'out' to terminate input/output\n");
  cnt = 0;

  while (1) {
    fprintf(stderr,"file name: " );
    fgets (filnam,sizeof(filnam),stdin);
    for(i=0;i<128;i++) {
      if(filnam[i] == '\n') {
	filnam[i] = '\0';
	break;
      }
    }

    if(strcmp("out",filnam) == 0) {
      fprintf(stderr,"output file name: " );

      fgets (filnam,sizeof(filnam),stdin);
      for(i=0;i<128;i++) {
	if(filnam[i] == '\n') {
	  filnam[i] = '\0';
	  break;
	}
      }
      if(strcmp("out",filnam) == 0) {
	exit(1);
      }
      if((fd = creat(filnam,0644)) == -1) {
	perror("cannot open for output");
	exit(1);
      }
      strcpy (&flhd.name[0],"his/");
      strncpy (&flhd.name[4], filnam, 11);	/* original data file name */
      flhd.name[15] = '\0';			/* allways zero */
      flhd.dtype = 2;		/* make everything float */
      for (i=0;i<flhd.maxid;i++)
	ndata[flhd.sinfo[i].offs] /= (float)cnt; /* for random substraction */

      if((write (fd, &flhd, sizeof(flhd)) != sizeof(flhd)) ||
	 (write (fd, ndata, flhd.len<<2) != flhd.len<<2)) {
	perror("writing data");
	exit(1);
      }
      close (fd);
      exit(0);
    }

    if ((fd = open (filnam, 0)) < 0) {       /* open data file */
      sprintf(errstr,"Cannot open %s",filnam);
      perror(errstr); 
      continue; 		  /* stop here if files don't exist */
    }
    if (read(fd,&flhd,sizeof(flhd)) != sizeof(flhd)) {
      fprintf(stderr,"error reading file header of %s\n",filnam);
      exit(1);
    }
    if (strncmp (&flhd.name[0], "his/", 4) &&
	strncmp (&flhd.name[0], "data/", 5)) {
      fprintf(stderr,"%s  not a data file\n",filnam);
      close(fd);
      continue;
    }
    if ( actual_read(fd,flhd.dtype,flhd.len) != flhd.len ) {
      fprintf(stderr,"data read failure\n");
      close (fd);
      continue;
    }
    for (i=0; i<flhd.len; i++)
	ndata[i] += hdata[i];
    cnt++;
  }
}

int actual_read(int fld,int dtyp,int num)
{
    register int i;
    char   dbuf[BUFSIZ];
    int   *intptr;
    short *shptr;
    int    nb, nd;
    int    total;


    total = 0;
    pd = hdata;
    dtyp %= 3;
    switch (dtyp) {
      case 0:			/* int */
	intptr = (int *)dbuf;
	do {
	    nb = read(fld,dbuf,BUFSIZ);
	    if(nb == 0) break;
	    nd = nb>>2;
	    if((total + nd) > num)
	      nd = num - total;
	    for(i=0;i<nd;i++)
	      *pd++ = (float) intptr[i];
	} while ((total += nd) < num);
	return(total);

      case 1:			/* short */
	shptr = (short *)dbuf;
	do {
	    nb = read(fld,dbuf,BUFSIZ);
	    if(nb == 0) break;
	    nd = nb>>1;
	    if((total + nd) > num)
	      nd = num - total;
	    for(i=0;i<nd;i++)
	      *pd++ = (float) shptr[i];
	} while ((total += nd) < num);
	return(total);

      case 2:
	nb = read(fld,pd,num<<2);
	return(nb>>2);

      default:
	return(-1);
    }
}
