/*      BGD and BGDPLT 
 *	draws background in sa
 *
 *	G.Kumbartzki
 *	03-04-85xf
 */

#include <math.h>
#include <X11/Xlib.h>
#include "dacf.h"

double bgd(double a)		/* function to calculate */
				/* individual background */
{				/* point */
	extern int *pmarks;
	extern double  bp[];

	register int i = pmarks[10];
	double bgd = bp[i];

	if(i == -1)
	    return(0.0);

	a -= (pmarks[5] + pmarks[0]) >> 1;
	while (--i >= 0)		/* Horners rule */
		bgd = bgd * a + bp[i];
	return(bgd);
}

void bgdplt()
{
    extern int fchan,len,mlog,ytop,ybot,yzero;
    extern int *pmarks,xzero;
    extern float yinc,xinc;
    extern Display *dpy;
    extern Window   gwin;
    extern GC gc;
    extern Pixmap  pixmap;
    extern struct colorlist color_vec[];
    extern float deca;
    XPoint p[300];

    int  npts;
    int	 ms, ml, x, y, ytemp;
    int  m2, m3;
    int  ylog;
    float       xi;
    double	func;
	
    ylog = mlog ? LOGD(0.0)*yinc : 0;
    y = 0;
    m2 = pmarks[2];
    m3 = pmarks[3];
    ms = pmarks[0];
    if(ms > m2) ms = m2 - 5;
    if(ms < fchan) ms = fchan;
    ml = pmarks[5];
    if(ml < m3) ml = m3 + 5;
    if(ml > fchan+len) ml = fchan + len;
    x = (ms - fchan + 0.5) * xinc + xzero;
    ml= (ml - fchan + 0.5) * xinc + xzero;
    npts = 0;
    for(  ;x <= ml;x += 3) {
	ytemp = y;
	xi = (x-xzero)/xinc + (float)fchan - 0.5;
	func = bgd((double)(xi));
	if(mlog) func = LOGD(func)-deca;
	y = ybot - func*yinc - yzero + ylog;
	if(y == ytemp) continue;
	p[npts].x = x;
	p[npts].y = LIM(y);
	npts++;
    }
    p[npts].x = x;
    p[npts].y = LIM(y);
    npts++;
    XSetForeground(dpy,gc,color_vec[4].pixel);
    XDrawLines(dpy,pixmap,gc,p,npts,CoordModeOrigin);
    XDrawLines(dpy,gwin,gc,p,npts,CoordModeOrigin);
}





