/*** convdata.c ***
 * convert data from DIGITAL to IBM Workstation *
 * character sequences unschanged
 * short integers bytes swaped (0 1 becomes 1 0)
 * integers byte sequene 0 1 2 3 becomes 3 2 1 0
 */ 

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <fcntl.h>

#include "dacf.h"

union {
    struct filehead flhd;
    char cbuf[sizeof(struct filehead)];
} header;




int main(argc,argv)
int argc;
char *argv[];
{
  char line[160];
  register int i,j;
  char tmp, in[1024];
  int nb;
  int datatype;
  int fd,fdn;


  if(argc == 1){
    printf("%s Byte swaps data file\n",*argv);
    printf("Argument: file name\n");
    exit(1);
  }
  i = 1;
  do{
    if(argc > 1 && (fd = open(argv[i],0)) == EOF){
      printf("cannot open file %s\n",argv[i]);
      continue;
    }
    if((fdn = creat("tmpfile",0644)) == EOF){
      printf("cannot open tmpfile\n");
      exit(1);
    }
    if((read(fd,&header,1024))<=0){
      printf("read error input file\n");
      unlink ("tmpfile");
      exit(1);
    }
    if(strncmp(&header.flhd.name[0],"data/*",6) &&
       strncmp(&header.flhd.name[0],"his/",4)){
      printf("Not a data file\n");
      close(fd);
      continue;
    }
				/* first 16 bytes are unchanged
				   rest are int*/
    for(j=16;j<1024;j+=4) {
      tmp = header.cbuf[j];
      header.cbuf[j] = header.cbuf[j+3];
      header.cbuf[j+3] = tmp;
      tmp = header.cbuf[j+1];
      header.cbuf[j+1] = header.cbuf[j+2];
      header.cbuf[j+2] = tmp;
    }
    write(fdn,&header,1024);
    datatype = header.flhd.dtype;
				/* datatype = 0 int 1-dim*/
				/* datatype = 1 short */
				/* datatype = 3 int matrix */
				/* datatype = 4 short matrix */
    datatype %= 3;
    if(datatype == 1) {	  /* swap two */
      while((nb = read(fd,in,1024))){
	for(j=0;j<nb;j+=2){
	  tmp = in[j];
	  in[j] =in[j+1];
	  in[j+1] = tmp;
	}
	write(fdn,in,nb);
      }
    }
    else if (datatype == 0) { /* swap four */
      while((nb = read(fd,in,1024))){
	for(j=0;j<nb;j+=4){
	  tmp = in[j];
	  in[j] =in[j+3];
	  in[j+3] = tmp;
	  tmp = in[j+1];
	  in[j+1] = in[j+2];
	  in[j+2] = tmp;
	}
	write(fdn,in,nb);
      }
    }
    else {
      printf("Floating point numbers: do not know how to swap\n");
    }
    close(fd);
    close(fdn);

    sprintf(line,"mv tmpfile %s",argv[i]);
    system(line);

  } while(++i < argc);
  unlink("tmpfile");
}
