/* New dacf.h for xsa 3-17-93 gkum */

/* Size definitions for SA */
#define MKNR    440	        /* max number of K (1024) Knr */
#define WRK      16             /* max Knr of work space */
				/* limits can be changed here
				 but check for shared mem size! */
#define HSIZ    (MKNR+WRK)*1024	/* max number of his-channels in SA */
#define WRKSIZ  WRK*1024	/* Size of work space */
#define NMARKS  100		/* max number of markers */
#define UDPNR   NMARKS/4	/* max up/down peak number */
#define SPEC    124		/* max number of spectra in his file -
				   limit size of filehead ! */
#define NSPEC   MKNR		/* Number of spectra limit in memory -
				   one per K */

#define KILO(a) (a<MKNR ? a*1024 : a)
#define LOGD(c)	(log10((double)(c < 1.0 ? 0.7 : c)))
#define LIM(a) (a > ybot ? ybot : (a < ytop ? ytop : a))
#define INSIDE(x) ((x > fchan)&&(x < fchan+len)) ? 1 : 0
				/* mod for setmark(,,mod,) */
#define WP 1			/* Window & Pixmap */
#define P  0			/* Pixmap only */
#define E  2			/* Erase (draw with background color) */

typedef double (*FUNCTION)();	/* pointer to function */

/*   A data file is proceeded by a Header Block of 512 Bytes
     Data are a 1-dim. array of numbers possibly organized in
     a set of separate spectra. For each spectrum the offset
     (its first channel in the array) is recorded in the file header.
*/

struct filehead {		/* new data file header Block 8-14-91 */
    char name[16];		/* Character line: "data/..." */
    int  nrun;			/* Run number */
    int  dtype;			/* Data Type: 0 long; 1 short unsigned */
    int  len;			/* Total Number of Channels */
    int  maxid;			/* Max Number of Spectra */
    struct {
	int id;			/* spectrum id */
	int offs;		/* begin of spectrum in file */
    } sinfo[SPEC];		/* id and offset of each spectrum */
};

struct hinfo {			/* Individual Histogram info */
    int id;			/* histogram id number */
    char title[16];		/* histogram title */
    int xma;			/* length of histogram */
    int offset;			/* offset in array */
    int cflag;			/* calibration flag */
    float sl;    		/* calibration slope */
    float zr;   		/* zero calibration */
};  

struct colorlist {
    char            name[12];
    unsigned int    pixel;
};

struct evnthead {
  char name[32];		/* text */
  int  byteorder;		/* byteorder indicator == 7 ok */
  int  nrun;			/* run number */
  int  type;			/* = 0 default
				   = 1 clover version
                                   = 2 clover gain matched */
  int  ndet;			/* number of detectors */
  int  mon;			/* monitor detector */
  int  npar;			/* number of parameters in event */
  int  parl;			/* particle spectrum length */
  int  gaml;			/* gamma spectrum length */
  int  monl;			/* monitor spectrum length */
  int  tdcl;			/* tac spectrum length */
  int  date;			/* date stamp */
  int  time;			/* "time in seconds since the Epoch" */
};

