/*      G.Kumbartzki
 *	draws graph of gaussfit
 *	function plot for sa	
 */

#include <math.h>
#include <X11/Xlib.h>
#include "dacf.h"

extern Display *dpy;
extern Window   gwin;
extern GC gc;
extern Pixmap  pixmap;
extern XColor red,yellow;

void fplot()
{
    extern int xzero,ybot,ytop,yzero;
    extern int fchan,len,mlog;
    extern int *pmarks;
    extern float xinc,yinc;
    extern double gpar[];
    extern float deca;
    extern double gauss(double xi, double par[]);

    register int x, y, ytemp;
    XPoint p[300];
    int  npts;
    int	 ms, ml;
    int  m2, m3;
    float  xi;
    double func;
    int ylog;

    ylog = mlog ? LOGD(0.0)*yinc : 0;
    y = 0;
    m2 = pmarks[2];
    m3 = pmarks[3];
    ms = pmarks[1];
    if(ms > m2) ms = m2 - 5;
    if(ms < fchan) ms = fchan;
    ml = pmarks[4];
    if(ml < m3) ml = m3 + 5;
    if(ml > fchan+len) ml = fchan + len;

    x = (ms - fchan + 0.5) * xinc + xzero;
    ml= (ml - fchan + 0.5) * xinc + xzero;
	
    npts = 0;
    for(  ;x <= ml;x += 3) {
	ytemp = y;
	xi = (x-xzero)/xinc + (float)fchan - 0.5;
	func = gauss(xi,gpar);
	if(mlog) func = LOGD(func)-deca;
	y = ybot - func*yinc - yzero + ylog;
	if(y == ytemp) continue;
	p[npts].x = x;
	p[npts].y = LIM(y);
	npts++;
    }
    p[npts].x = x;
    p[npts].y = LIM(y);
    npts++;
    p[npts].x = p[0].x;
    p[npts].y = p[0].y;
    /*
    XSetForeground(dpy,gc,yellow.pixel);
    XFillPolygon(dpy,gwin,gc,p,npts+1,Complex,CoordModeOrigin);
    */
    XSetForeground(dpy,gc,red.pixel);
    XDrawLines(dpy,pixmap,gc,p,npts,CoordModeOrigin);
    XDrawLines(dpy,gwin,gc,p,npts,CoordModeOrigin);
}
