 /*   program: ful.c                Ralf H. Mayer                      8/97 
  *  
  *   made subroutine for xsa
  *
  */
#include <math.h>
#include <stdlib.h>
#include "dacf.h"

int genful()
{
  register int i,j;
  float kinc;
  float k;
  float chi_sqr;
  float chi_sqr_sum;
  float mod_chi_sqr_sum;

  float *ful;
  float *ful_smooth;
  float *ful_subtr;
  int   startloop,endloop;
  int   fill;
  int   cnt;
  static int ruler = 15;

  extern int     len;                    /* Data length */
  extern struct  hinfo *spc[], *hptr;
  extern float  *hdat, *pdat;
  extern char   *wptr[];		 /* word pointer array */
  extern int     ntrs;			 /* number entries */
  extern int     fchan;			 /* first channel */
  extern int     getid(int n);
   
  if (ntrs) {
    i = atoi(wptr[1]);
    hptr = spc[getid(i)];
    pdat = hdat + hptr->offset;
    if(ntrs > 1)
      ruler = atoi(wptr[2]);
  }
  startloop = fchan;
  if(startloop < ruler)
    startloop = ruler;
  endloop = fchan + len;
  fill = 0;
  if(endloop >= hptr->xma) {
    endloop = hptr->xma - ruler;
    fill = 1;
  }
  spc[0]->xma = hptr->xma;

/******************************************************************************
    Generating FUL spectrum.
******************************************************************************/
    ful = hdat + MKNR*1024;		/* put into work space */

    for(i=startloop;i<endloop;i++){
      k = pdat[i];
      for(j=i-ruler;j<=i+ruler;j++){
	if(pdat[j] < k){
          k = pdat[j];
        }
      }
      if(k <= 0.0)
	kinc = 1;
      else
	kinc = sqrt((double)k);
      mod_chi_sqr_sum = 0.0;
      cnt = 20;
      while(mod_chi_sqr_sum < 0.5 && --cnt){
        k = k + (0.51- mod_chi_sqr_sum)*kinc;
        chi_sqr_sum = 0.0;
        for(j=i-ruler;j<=i+ruler;j++){
          if(pdat[j] <= k){
	    chi_sqr = (k - pdat[j])*(k - pdat[j]) / k;
            chi_sqr_sum += chi_sqr;
          }
	}
	mod_chi_sqr_sum = chi_sqr_sum / (float)(2*ruler+1);
      }
      /*      printf ("cnt = %d chi = %.2f\n",cnt, mod_chi_sqr_sum); */
      ful[i] = k;
    }
    for (i=fchan;i<startloop;i++)
      ful[i] = ful[startloop];
    if(fill)
      for (i=endloop;i<len;i++)
	ful[i] = ful[i-1];

/******************************************************************************
    Generating smooth FUL spectrum.
******************************************************************************/
    {
      int lo, hi;
      ful_smooth = ful + hptr->xma;
      for(i=fchan;i<len;i++){
        lo = i - 2*ruler;
	hi = i + 2*ruler;
	if(lo < fchan)
	  lo = fchan;
	if(hi > len)
	  hi = len;
	ful_smooth[i] = 0.0;
	for (j=lo;j<hi;j++)
	  ful_smooth[i] += ful[j];
	ful_smooth[i] /= (hi - lo +1);
      }
    }
/******************************************************************************
    Generating smooth FUL subtracted spectrum.
******************************************************************************/
    ful_subtr = ful;		/* over write ful */
    for(i=fchan;i<fchan+len;i++){
       ful_subtr[i] = pdat[i] - ful_smooth[i];
    }
    pdat = hdat + MKNR*1024;	/* fixed for work space */
    return (0);
}
