/* matrix inversion: return det of quadr. matrix */
/* after Bevington */
#include <math.h>


double matinv(double array[][12],int order)
{
    register int i,j,k,m;
    int ik[12],jk[12];
    double save,max,det;

    det =1.0;

    for(k = 0;k < order; k++) {
				/* find largest element array[i][j] */
	max = 0.0;
      loop:
	for(i = k; i < order; i++)
	  for(j = k; j < order; j++)
	      if(fabs(max) <= fabs(array[i][j])) {
		  max = array[i][j];
		  ik[k] = i;
		  jk[k] = j;
	      }
				/* interchange rows and coumns to put
				 max in array[k][k] */
	if(max == 0.0) return(0.0);
	i = ik[k];
	if(i < k) goto loop;
	if(i > k)
	  for( j = 0; j < order; j++){
	      save = array[k][j];
	      array[k][j] = array[i][j];
	      array[i][j] = -save;
	  }
	j = jk[k];
	if(j < k) goto loop;
	if(j > k)
	  for(i = 0; i < order; i++){
	      save = array[i][k];
	      array[i][k] = array[i][j];
	      array[i][j] = -save;
	  }
				/* accumulate elements of inverse matrix */
	for(i = 0; i< order; i++)
	  if(i != k)
	    array[i][k] /= -max;
	for(i = 0; i < order; i++)
	  for(j = 0; j < order; j++)
	    if(i != k && j != k)
	      array[i][j] += array[i][k]*array[k][j];
	for(j = 0; j < order; j++)
	  if(j != k)
	    array[k][j] /= max;
	array[k][k] = 1.0/max;
	det *= max;
    }
				/* restore ordering of matrix */
    for(m = 0; m < order; m++){
	k = order - m - 1;
	j = ik[k];
	if(j > k)
	  for(i = 0; i< order; i++) {
	      save = array[i][k];
	      array[i][k] = -array[i][j];
	      array[i][j] = save;
	  }
	i = jk[k];
	if(i > k)
	  for(j = 0; j < order; j++) {
	      save = array[k][j];
	      array[k][j] = -array[i][j];
	      array[i][j] = save;
	  }
    }
    return(det);
}

    
