/* SA_ouput.c
 *
 *  output for Xsa
 *  06/19/87  G.Kumbartzki
 */


#include <stdio.h>
#include "dacf.h"

void output()
{
    extern int npks,repeat;
    extern int npeak, *pmarks;
    extern double gpar[],sigm[],bp[],chi;
    extern struct hinfo *hptr;
    extern char sadatfile[];

    static char mfold[4][11] = {"singlet","doublet","triplet",
				  "quadruplet"};
    static int oldid = 0;

    register int i;
    extern float calbrt(double);
    FILE *fopen(),*op,*fp;

    printf("peak#: %d\n",npeak);
    for(i=0;i<npks;i++) {
      printf("pos: %.2f    sum:  %.1f(%.1f)    fwhm:  %.2f(%.2f)\n",
	     calbrt(gpar[3*i+1]), gpar[3*i],sigm[3*i],
	     hptr->sl*gpar[3*i+2],hptr->sl*sigm[3*i+2]);
    }
    printf("chisq: %.3f\n",chi);

    /* output to sa.dat and results.dat file */

    if((op=fopen(sadatfile,"a")) != NULL && 
       (fp = fopen("results.dat","a")) != NULL){

	if(hptr->id != oldid) {
	    fprintf(op,"\n%s:%d\n",hptr->title,hptr->id);
	    fprintf(fp,"%s:%d\n",hptr->title,hptr->id);
	    oldid = hptr->id;
	}

	fprintf(op,"\n\n     GAUSS fit: %s\tchi = %2.3f\n",
		mfold[npks-1],chi);
	fprintf(op,"     Peak marker ");
	for(i=6;i<10;i++) {
	  if(pmarks[i] != -1)
	    fprintf(op," %6d",pmarks[i]);
	}
	fprintf(op,"\n     backgd:  polynom = %d     pars: %7.3f",
		pmarks[10],bp[0]);
	for(i=1;i<pmarks[10]+1;i++)
	  fprintf(op,"  %6.3f",bp[i]);
	fputs("\n\n     peak #  energy    centroid   peaksum    fwhm    en_fwhm",op);
	fprintf(op,"\n\n    ");
	for(i=0;i<npks;i++) {
	  if(i > 0) fprintf(op,"    ");
	  fprintf(op," %3d   %8.2f   %8.2f   %8.2f   %6.2f%9.2f\n", i+1,
		  calbrt(gpar[3*i+1]),gpar[3*i+1],gpar[3*i],
		  gpar[3*i+2],hptr->sl*gpar[3*i+2]);
	  fprintf(op,"%19.2f   %8.2f   %8.2f   %6.2f%9.2f\n",
		  hptr->sl*sigm[3*i+1],sigm[3*i+1],sigm[3*i],
		  sigm[3*i+2],hptr->sl*sigm[3*i+2]);
	  fprintf(fp,"%10.2f%10.2f%10.2f\n",calbrt(gpar[3*i+1]),
		  gpar[3*i],sigm[3*i]);
	}					/* end of for */
	repeat = 1;
	fclose(op);
	fclose(fp);
    }
}
