/* 
   programm allocates shared memory segments for online
   data sorting

   5-25-97
   gkum

   the shm size is limited on some machines, like io
   therfore MKNR (data size) has to be limited. xsa has to be compiled
   with the same MKNR !

*/

#include <stdio.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#include "dacf.h"

main(argc, argv)
int argc;
char *argv[];
{
    int shmflg = 0644;
    int old_id[2];
    int id1,id2, size_bytes;
    int i, fd;
    char buf[80];
    extern char *getenv();
    char *pspath, confname[64];

    float *hdp;			     /* pointer to histograms */
    struct hinfo *hptr[NSPEC+1];

    if((pspath = getenv("HOME")) != NULL) {
      strcpy(confname,pspath);
      strcat(confname,"/SHM.conf");
    }
    else
      strcpy(confname,"SHM.conf");


    /* check to see if master segment alread exist */
    old_id[0] = 0;
    if((fd = open (confname, 0))  > 0) {
      read(fd,buf,80);
      sscanf(buf,"%*s %*s %*s %*s %*s %d %d", &old_id[0], &old_id[1]);
      close(fd);
      printf("found id %d %d\n",old_id[0], old_id[1]);
      system ("ipcs -m");
    }
    if(old_id[0] != 0) {
	
      /* try to attach to existing master segment */

      printf("\n   <==  PROBING OLD SHARED MEMORY SEGMENTS  ==>   \n");

      if(shmat(old_id[0],0,SHM_RND) == (char *)-1) {
	perror("SHM.conf information obsolete");
      }
      else {
	printf("\n             <== SHARED MEMORY OK ==> \n");
      }
      exit(0);
    }
    else {
	/* create master segment and write id number in configuration file */

      printf("\n   <==  CREATING NEW SHARED MEMORY SEGMENTS  ==>   \n");
      if((fd = creat(confname, 0644)) < 0) {
	perror("SHM.conf");
	exit(1);
      }
    
      /* create shared memory segments and store id numbers
	 in SHM.conf file */
    
      size_bytes = (NSPEC+1)*sizeof(struct hinfo); /* info segment */
      if((id1 = shmget(IPC_PRIVATE, size_bytes, shmflg))< 0) {
	perror("Info segment");
	close(fd);
	exit(1);
      }
      printf("Histogram info segment id %d\n",id1);

      size_bytes = HSIZ*sizeof(float); /* histogram space */
      if((id2 = shmget(IPC_PRIVATE, size_bytes, shmflg)) < 0) {
	perror("Data segment");
	close(fd);
	exit(1);
      }
      printf("Histogram data segment id %d\n",id2);
    }
    sprintf(buf,"SHARED MEMORY SEGMENTS FOR XSA: %d %d\n",id1, id2);
    write(fd,buf,strlen(buf));
    close(fd);
}
